<style type="text/css" scoped="">
.add_title{
  padding-top: 0px;
}
.chain_msg_dialog{
  border: 1px solid #D6DAE2;
  font-size: 12px;
  line-height: 24px;
  padding: 15px;
  word-break: break-all;
}
.c_item{
  padding-bottom: 10px;
}
.c_title{
  color: #3B3B3B;
  color: #828282;
}
.c_gray{
  color: #D6DAE2;
  color: #3B3B3B;
}
.blue_ft{
  color: blue;
}
.to_chain_load_ct{
  margin-top: 55px;
}
.to_chain_load_ct .c_gray{
  text-align: center;
}
.msg_to_chain_bg{
  background-position: center;
}
</style>
<template>
  <div>
    <concat_dialog_form 
    :err_msg="form_config.err_msg"
    :bg_class="bg_class"
    :list="list" 
    :show_close="form_config.show_close"
    :with_submit="form_config.with_submit"
    @close="close" 
    @submit="close">


      <template>
        <div class="add_title" slot="title">
          {{ form_config.status_title }}
        </div>

        <div class="chain_msg_dialog" slot="concat_content">

          <div class="c_item" v-for="row, _index in chain_msg" :key="_index">
            <div class="c_title">
              {{ row.text }}
            </div>
            <div class="c_gray" :class="row.class">
              {{ row.value }}
            </div>
          </div>

        </div>
        
        <div slot="submit">
          <load_area :on_load="form_config.on_load" :btn_text="form_config.btn_text" :circle_class="form_config.circle_class"></load_area>
        </div>
      </template>
    </concat_dialog_form>
  </div>
</template>
<script>
import base_dialog from '@/components/base_dialog.vue'
import concat_form from '@/components/concat_form.vue'
import concat_dialog_form from '@/modules/admins/concat_dialog_form.vue'
import load_area from '@/components/load_area.vue'
import {
  sha256,
  random_words,
  wait_time,
  fix_str_len,
  format_date_str
} from '@/modules/utils'
import {
  create_sku_code,
  add_hash_to_chain
} from '@/service'
import {
  get_token
} from '@/modules/stores'

export default {
  data () {
    return {
      form_val: {},
      bg_class: 'msg_to_chain_bg',
      form_config: {
        on_load: false,
        btn_text: '存证信息',
        circle_class: 'global_load_circle',
        show_close: true,
        status_title: '存证信息',
        with_submit: false,
        err_msg: ''
      },
      chain_msg: [
        {
          'text': '区块哈希',
          'name': 'block_hash',
          'value': '95B9A9374AFAD060FA615F63FCE4F830B44',
          'type': 'hash',
        },
        {
          'text': '存证时间',
          'name': 'record_time',
          'value': '2020-02-02 12:12:12',
          'type': 'date_str'
        },
        {
          'text': '哈希算法',
          'name': '',
          'value': 'SHA256',
          'type': 'str'
        },
        {
          'text': '数据',
          'name': 'data',
          'value': '95B9A9374AFAD060FA615F63FCE4F830B44',
          'type': 'data_str',
        },
        {
          'text': '数据哈希',
          'name': 'data_hash',
          'value': '95B9A9374AFAD060FA615F63FCE4F830B44',
          'type': 'hash',
        },
        {
          'text': '存证状态',
          'name': '',
          'value': '存证成功',
          'class': 'blue_ft',
          'type': 'str'
        },
      ]
    }
  },
  props: {
    data: {
      type: Object,
      default () {
        return {}
      }
    }
  },
  watch: {
    data () {
      // alert('changed')
    }
  },
  computed: {
    chain_msg_form () {
      let chain_msg_form = {}
      this.chain_msg.forEach(i => {
        chain_msg_form[i.name] = i.value
      })
      chain_msg_form.product_id = this.data.goodsId
      return chain_msg_form
    }
  },
  mounted () {
    console.log(this.value);
    console.log(this.data);
    this.init_data();
  },
  methods: {
    init_data () {
      this.chain_msg.forEach((item, index) => {
        if(this.data[item.name]){
          item.value = this.data[item.name]
        }
      });
    },
    set_chain_msg_by_name (name, value) {
      this.chain_msg.forEach(i => {
        if(i.name == name){
          i.value = value;
        }
      });
    },
    get_chain_msg_by_name (name) {
      // return this.
    },
    async init_chain_msg () {
      // const cur_time = format_date_str(new Date())
      // let block_hash = this.chain_msg.find(i => i.name == 'block_hash')
      // block_hash.value = await sha256( random_words(20) )

      // let record_time = this.chain_msg.find(i => i.name == 'record_time')
      // record_time.value = cur_time

      // let data = this.chain_msg.find(i => i.name == 'data')
      // let data_hash = this.chain_msg.find(i => i.name == 'data_hash')
      // data_hash.value = await sha256(data.value)

      // await add_hash_to_chain(this.chain_msg_form)
      // await wait_time(3);
      // this.$router.push({
      //   name: 'product_hash_manage',
      //   params: {
      //     'recent_product_id': this.data.goodsCode
      //   }
      // })
      // this.chain_msg.find(i => i.text == '存证状态').value = '存证成功';
      // this.form_config.with_submit = true;
      // this.form_config.on_load = false;
      // this.form_config.btn_text = '存证成功, 点击关闭';
      // this.form_config.status_title = '存证成功';
      // this.form_config.show_close = true;
    },
    close () {
      if(this.form_config.on_load) return ;
      this.$emit('close');
    }
  },
  components: {
    base_dialog,
    concat_form,
    load_area,
    concat_dialog_form
  }
}
</script>
